onEvent('recipes', (event) => {

    const id_prefix = 'immersiveengineering:kubejs/shapeless';
    const blueprints = [
        'bannerpatterns',
        'bullet',
        'components',
        'electrode',
        'molds',
        'specialBullet'
    ];

    blueprints.forEach((blueprint) => {
        event.shapeless(
            Item.of('immersiveengineering:blueprint', `{blueprint:"${blueprint}"}`),
            [Item.of('immersiveengineering:blueprint', `{blueprint:"${blueprint}"}`), 'create:crafting_blueprint']
        ).keepIngredient('immersiveengineering:blueprint').id(`${id_prefix}/blueprint/${blueprint.toLowerCase()}`);
    });
    
});